<?php

include 'XMPPHP/XMPP_Old.php';
include 'xmlrpc/xmlrpc.inc';

$blog_usuario = 'usuario';
$blog_contraseña = 'contraseña';
$blog_url = 'blog.com';
$blog_xmlrpc_path = '/xmlrpc.php';
$blog_puerto = 80;

$post_tags = array('tag1', 'tag2');
$post_separador = '##';
$post_titulo_defecto = 'Título por defecto';
$post_insertar_p = true;

$jabber_host = 'gtalk.google.com';
$jabber_contraseña = 'contraseña';
$jabber_usuario = 'usuario';
$jabber_puerto = 5222;


function post($message) {
  global $blog_usuario;
  global $blog_contraseña;
  global $blog_url;
  global $blog_xmlrpc_path;
  global $blog_puerto;
  global $post_tags;
  global $post_separador;
  global $post_titulo_defecto;
  global $post_insertar_p;
  
  $aux = split($post_separador, $message, 3);
  if (count($aux) == 1) {
    $titulo = $post_titulo_defecto;
    $contenido = $message;  
    $tags = implode(',', $post_tags);
  } else {
    $titulo = $aux[0];
    $contenido = $aux[1];  
    $tags = (count($aux) == 2)? implode(',', $post_tags) : $aux[2];
  }
  
  if ($post_insertar_p) {
    $contenido = implode("\n", array_map(create_function('$e', 'return "<p>$e</p>";'), explode("\n", $contenido)));
  }

  $f = new xmlrpcmsg('wp.getUsersBlogs',
		array(php_xmlrpc_encode($blog_usuario), php_xmlrpc_encode($blog_contraseña))
	);

	$c=new xmlrpc_client($blog_xmlrpc_path, $blog_url, $blog_puerto);
	$c->setDebug(0);
	$r=&$c->send($f);
	if(!$r->faultCode()) {
		$v=$r->value();
    $datos = simplexml_load_string($v->serialize());
    $blogid = $datos->xpath('//member/name[. ="blogid"]/following-sibling::*/string');
    $blogid = is_array($blogid) ? (string) $blogid[0] : (string) $blogid;    
    $f = new xmlrpcmsg('metaWeblog.newPost',
  		array(php_xmlrpc_encode($blogid), php_xmlrpc_encode($blog_usuario), php_xmlrpc_encode($blog_contraseña), php_xmlrpc_encode(array('title'=>$titulo, 'description'=>$contenido, 'mt_keywords'=>$tags)), php_xmlrpc_encode(1))
  	);
  	$c=new xmlrpc_client($blog_xmlrpc_path, $blog_url, $blog_puerto);
  	$c->setDebug(0);
  	$r=&$c->send($f);
  	if($r->faultCode())	{
  		return "Ha habido un error al intentar crear un nuevo post [".$r->faultString()."]";
  	} else {
      $datos = simplexml_load_string($r->serialize());
      $postid = $datos->xpath('//value/string');
      $postid = is_array($postid) ? (string) $postid[0] : (string) $postid;    
   
      $f = new xmlrpcmsg('metaWeblog.getPost',
    		array(php_xmlrpc_encode($postid), php_xmlrpc_encode($blog_usuario), php_xmlrpc_encode($blog_contraseña))
    	);
    	$c=new xmlrpc_client($blog_xmlrpc_path, $blog_url, $blog_puerto);
    	$c->setDebug(0);
    	$r=&$c->send($f);
    	if($r->faultCode())	{
    		return "Ha habido un error al intentar recuperar información sobre el post insertado [".$r->faultString()."]";
    	} else {
        $datos = simplexml_load_string($r->serialize());
        $permalink = $datos->xpath('//member/name[. ="permaLink"]/following-sibling::*/string');
        $permalink = is_array($permalink) ? (string) $permalink[0] : (string) $permalink;    
        $title = $datos->xpath('//member/name[. ="title"]/following-sibling::*/string');
        $title = is_array($title) ? (string) $title[0] : (string) $title;  
        return "Se ha publicado '$title': $permalink";  
      }
    }

	} else {
		return "Ha habido un error al intentar recuperar información sobre el blog [".$r->faultString()."]";
	}
}

//Use XMPPHP_Log::LEVEL_VERBOSE to get more logging for error reports
//If this doesn't work, are you running 64-bit PHP with < 5.2.6?
$conn = new XMPPHP_XMPPOld($jabber_host, $jabber_puerto, $jabber_usuario, $jabber_contraseña, 'xmpphp', $jabber_host, $printlog=false, $loglevel=XMPPHP_Log::LEVEL_ERROR);
$conn->autoSubscribe();
$conn->useEncryption(false);

try {
    $conn->connect();
    while(!$conn->isDisconnected()) {
    	$payloads = $conn->processUntil(array('message', 'presence', 'end_stream', 'session_start'));
    	foreach($payloads as $event) {
    		$pl = $event[1];
    		switch($event[0]) {
    			case 'message': 
    			  if (trim($pl['body']) == '') break;
    				$conn->message($pl['from'], $body=post($pl['body']), $type=$pl['type']);
    				if($pl['body'] == 'quit') $conn->disconnect();
    				if($pl['body'] == 'break') $conn->send("</end>");
    			break;
    			case 'presence':
    				print "Presence: {$pl['from']} [{$pl['show']}] {$pl['status']}\n";
    			break;
    			case 'session_start':
    			  print "Empezamos\n";
			    	$conn->getRoster();
    				$conn->presence($status="A tus órdenes!!");
    			break;
    		}
    	}
    }
} catch(XMPPHP_Exception $e) {
  echo 'ERROR:';
  die($e->getMessage());
}
